package com.dcsoft.system.domain.vo;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

import com.dcsoft.system.domain.SysBranch;
import com.dcsoft.system.domain.SysPoint;
import com.dcsoft.system.domain.SysSpace;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.dcsoft.system.api.domain.SysDept;
import com.dcsoft.system.domain.SysMenu;

/**
 * Treeselect树结构实体类
 *
 * @author dcsoft
 */
public class TreeSelect implements Serializable
{
    private static final long serialVersionUID = 1L;

    /** 节点ID */
    private Long id;

    /** 节点名称 */
    private String label;

    /** 子节点 */
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<TreeSelect> children;

    /** 父级Id */
    private Long parentId;


    public TreeSelect()
    {

    }

    public TreeSelect(SysDept dept)
    {
        this.id = dept.getDeptId();
        this.label = dept.getDeptName();
        this.children = dept.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    public TreeSelect(SysMenu menu)
    {
        this.id = menu.getMenuId();
        this.label = menu.getMenuName();
        this.children = menu.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    /**
     * 模块转换
     */
    public TreeSelect(SysSpace space) {
        this.id = space.getId();
        this.label = space.getName();
        this.children = space.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());

    }

    /**
     * 菜单转换
     */
    public TreeSelect(SysPoint point) {
        this.id = point.getId();
        this.parentId = point.getSpaceId()==0L ? point.getId(): point.getSpaceId();
        this.label = point.getName();
    }

    public TreeSelect(SysBranch branch) {
//        this.id = branch.getId();
        this.label = branch.getName();
        this.children = branch.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());

    }

    public Long getId()
    {
        return id;
    }

    public void setId(Long id)
    {
        this.id = id;
    }

    public String getLabel()
    {
        return label;
    }

    public void setLabel(String label)
    {
        this.label = label;
    }

    public List<TreeSelect> getChildren()
    {
        return children;
    }

    public void setChildren(List<TreeSelect> children)
    {
        this.children = children;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }
}
